#include<stdio.h>
#include<dir.h>
#include<string.h>

struct fontfileheader{
char tag[8];
int reserved[4];
int npointers;
char pointertype;
long offsettoinfo;};

struct entryheader{
int size;
long next;
int devicetype;
char devicename[8];
int codepage;
int reserved[3];
long pointertofont;};

struct fontdataheader{
int reserved;
int nfonts;
int length;};

struct displayheader{
char rows;
char cols;
int aspectratio;
int nchars;};

int main(int argc, char **argv){
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];
char filename[MAXPATH];
char bitmap[2048];
unsigned char id, height;
FILE *pf;
int i, j;

struct fontfileheader ffh;
struct entryheader eh;
struct fontdataheader fdh;
struct displayheader dh;
int nentries=1;

ffh.tag[0]=255;
ffh.tag[1]='F';
ffh.tag[2]='O';
ffh.tag[3]='N';
ffh.tag[4]='T';
ffh.tag[5]=' ';
ffh.tag[6]=' ';
ffh.tag[7]=' ';
ffh.reserved[0]=ffh.reserved[1]=ffh.reserved[2]=ffh.reserved[3]=0;
ffh.npointers=1;
ffh.pointertype=1;
ffh.offsettoinfo=23L;
eh.size=28;
eh.next=0L;
eh.devicetype=1;
eh.devicename[0]='E';
eh.devicename[1]='G';
eh.devicename[2]='A';
eh.devicename[3]=' ';
eh.devicename[4]=' ';
eh.devicename[5]=' ';
eh.devicename[6]=' ';
eh.devicename[7]=' ';
eh.reserved[0]=eh.reserved[1]=eh.reserved[2]=0;
eh.pointertofont=53;
fdh.reserved=1;
fdh.nfonts=3;
fdh.length=9746;
dh.aspectratio=0;
dh.nchars=256;
dh.cols=8;

if (argc>1)
  strcpy(filename,argv[1]);
else{
  puts("\nFile name?");
  gets(filename);}

if((pf=fopen(filename,"rb"))==NULL){
  puts("\nUnable to open file");
  return -1;}
fseek(pf,13L,SEEK_SET);
fread(&height,1,1,pf);
fread(&id,1,1,pf);
eh.codepage=id;
printf("\nCP=%d",eh.codepage);
fseek(pf,-2048L,SEEK_END);
fread(bitmap,1,2048,pf);
fclose(pf);

for(i=0;i<2048;i++){
  char c=0;
  if((i%8)<height)
    for(j=0;j<8;j++)
      if(bitmap[i] & (1<<j))
	c|=(1<<(7-j));
  bitmap[i]=c;}

fnsplit(filename,drive,dir,file,ext);
fnmerge(filename,drive,dir,file,".CPI");
if((pf=fopen(filename,"wb"))==NULL){
  puts("\nUnable to open output file");
  return -2;}
fwrite(&ffh,sizeof(struct fontfileheader),1,pf);
fwrite(&nentries,sizeof(int),1,pf);
fwrite(&eh,sizeof(struct entryheader),1,pf);
fwrite(&fdh,sizeof(struct fontdataheader),1,pf);
dh.rows=16;
fwrite(&dh,sizeof(struct displayheader),1,pf);
for(i=0;i<2048;i++){
  fwrite(bitmap+i,1,1,pf);
  fwrite(bitmap+i,1,1,pf);}
dh.rows=14;
fwrite(&dh,sizeof(struct displayheader),1,pf);
for(i=0;i<256;i++){
  fwrite(bitmap+8*i,1,1,pf);
  for(j=1;j<7;j++){
    fwrite(bitmap+8*i+j,1,1,pf);
    fwrite(bitmap+8*i+j,1,1,pf);}
  fwrite(bitmap+8*i+7,1,1,pf);}
dh.rows=8;
fwrite(&dh,sizeof(struct displayheader),1,pf);
fwrite(bitmap,1,2048,pf);
fclose(pf);

return 0;}