#include<stdio.h>
#include<alloc.h>
#include<string.h>

struct fontfileheader{
char tag[8];
int reserved[4];
int npointers;
char pointertype;
long offsettoinfo;};

int nentries;

struct entryheader{
int size;
long next;
int devicetype;
char devicename[8];
int codepage;
int reserved[3];
long pointertofont;};

struct fontdataheader{
int reserved;
int nfonts;
int length;};

struct displayheader{
char rows;
char cols;
int aspectratio;
int nchars;};

int main(int argc, char **argv){
char nombre[80];
FILE *pf;
struct fontfileheader ffh;
struct entryheader *eh;
int i;

if (argc>1)
  strcpy(nombre,argv[1]);
else{
  puts("\nFile name?");
  gets(nombre);}

if((pf=fopen(nombre,"rb"))==NULL){
  puts("\nUnable to open file");
  return -1;}

fread(&ffh,sizeof(struct fontfileheader),1,pf);
printf("\nTag (FF): %x\t%c%c%c%c%c%c%c",ffh.tag[0],ffh.tag[1],ffh.tag[2],ffh.tag[3],ffh.tag[4],ffh.tag[5],ffh.tag[6],ffh.tag[7]);
printf("\nReserved: %d %d %d %d",ffh.reserved[0],ffh.reserved[1],ffh.reserved[2],ffh.reserved[3]);
printf("\nNo. of pointer in header: %d",ffh.npointers);
printf("\nType of pointer: %d",ffh.pointertype);
printf("\nOffset to info from start of file: %ld",ffh.offsettoinfo);
fread(&nentries,sizeof(int),1,pf);
printf("\nNo. of entries: %d",nentries);
if((eh=(struct entryheader *)malloc(nentries*sizeof(struct entryheader)))==NULL){
  puts("\nMemory problem");
  return -5;}
for(i=0;i<nentries;i++){
  struct fontdataheader fdh;
  int j;
  fread(eh+i,sizeof(struct entryheader),1,pf);
  printf("\n---Entry %d/%d",i,nentries);
  printf("\nSize of code (28): %d",eh[i].size);
  printf("\nPointer to next entry: %ld",eh[i].next);
  printf("\nDevice type: %d :: %s",eh[i].devicetype,eh[i].devicetype==1?"display":"printer");
  printf("\nDevice name (ID): %c%c%c%c%c%c%c%c",eh[i].devicename[0],eh[i].devicename[1],eh[i].devicename[2],eh[i].devicename[3],eh[i].devicename[4],eh[i].devicename[5],eh[i].devicename[6],eh[i].devicename[7]);
  printf("\nCode page ID: %d",eh[i].codepage);
  printf("\nReserved (0): %d %d %d",eh[i].reserved[0],eh[i].reserved[1],eh[i].reserved[2]);
  printf("\nPointer to font info: %ld",eh[i].pointertofont);
  fread(&fdh,sizeof(struct fontdataheader),1,pf);
  printf("\nReserved (1): %d",fdh.reserved);
  printf("\nNo. of fonts: %d",fdh.nfonts);
  printf("\nLength of font data: %d",fdh.length);
  if(eh[i].devicetype==1){
    for(j=0;j<fdh.nfonts;j++){
      struct displayheader dh;
      char data[8192];
      int ch;
      printf("\n   Font %d/%d",j,fdh.nfonts);
      fread(&dh,sizeof(struct displayheader),1,pf);
      printf("\nr x c : %d x %d",dh.rows,dh.cols);
      printf("\nAspect ratio (0): %d",dh.aspectratio);
      printf("\nNo. of chars: %d",dh.nchars);
      fread(data,((int)dh.rows*(int)dh.cols)/8,dh.nchars,pf);
      for(ch=0;ch<dh.nchars;ch++){
	int r;
	printf("\n   :char %d/%d:",ch,dh.nchars);
	for(r=0;r<dh.rows;r++){
	  int c;
	  printf("\n:");
	  for(c=0;c<dh.cols;c++){
	    int index=ch*((int)dh.rows*(int)dh.cols)/8+r*(int)dh.cols/8+c/8;
	    if(data[index] & (1<<(7-c%8)))
	      printf("");
	    else
	      printf(" ");
	    }
	  printf(":");}
	}
      }
    }
  fseek(pf,eh[i].next,SEEK_SET);}
return 0;}