#include<stdio.h>
#include<alloc.h>
#include<string.h>

#define word  unsigned int
#define dword unsigned long
#define byte  unsigned char

struct fontinfo{
word dfVersion;
dword dfSize;
char dfCopyright[60];
word dfType;
word dfPoints;
word dfVertRes;
word dfHorizRes;
word dfAscent;
word dfInternalLeading;
word dfExternalLeading;
byte dfItalic;
byte dfUnderline;
byte dfStrikeOut;
word dfWeight;
byte dfCharSet;
word dfPixWidth;
word dfPixHeight;
byte dfPitchAndFamily;
word dfAvgWidth;
word dfMaxWidth;
byte dfFirstChar;
byte dfLastChar;
byte dfDefaultChar;
byte dfBreakChar;
word dfWidthBytes;
dword dfDevice;
dword dfFace;
dword dfBitsPointer;
dword dfBitsOffset;
byte dfReserved;
/************
dword dfFlags;
word dfAspace;
word dfBspace;
word dfCspace;
dword dfColorPointer;
byte dfReserved1[16];
************/
};

struct GlyphEntry{
word geWidth;
word geOffset;};

struct typeinfo{
word id;
word n;
dword reserved;};

struct nameinfo{
word off;
word len;
word flags;
word id;
word handle;
word usage;};

unsigned int nentries=0;
unsigned int nfacename=0;
unsigned int ndevicename=0;

struct GlyphEntry *dfCharTable;
char *facename;
char *devicename;

void muestra(unsigned p, FILE *pf){
unsigned act=ftell(pf);
byte **charmap;
int i;
struct fontinfo fi;
byte t;

fseek(pf,p,SEEK_SET);
fread(&fi,sizeof(struct fontinfo),1,pf);
nentries=2+fi.dfLastChar-fi.dfFirstChar;
dfCharTable=(struct GlyphEntry *)malloc(nentries*sizeof(struct GlyphEntry));
fread(dfCharTable,sizeof(struct GlyphEntry),nentries,pf);
fseek(pf,p+fi.dfFace,SEEK_SET);
t=1;
while(t){
  fread(&t,1,1,pf);
  nfacename++;}
fseek(pf,p+fi.dfFace,SEEK_SET);
facename=(char *)malloc(nfacename);
fread(facename,1,nfacename,pf);
fseek(pf,p+fi.dfDevice,SEEK_SET);
t=1;
printf("\n\n");
while(t){
  fread(&t,1,1,pf);
  ndevicename++;}
fseek(pf,p+fi.dfDevice,SEEK_SET);
devicename=(char *)malloc(ndevicename);
fread(devicename,1,ndevicename,pf);

printf("\nDevice: %s\t\tFace: %s",devicename,facename);
printf("\nVersion: %u, Size: %lu",fi.dfVersion,fi.dfSize);
printf("\nCopyright notice: %s",fi.dfCopyright);
printf("\nType: %u, Points: %u, VertRes: %u, HorzRes: %u",fi.dfType,fi.dfPoints,fi.dfVertRes,fi.dfHorizRes);
printf("\nAscent: %u, InternalLeading: %u, ExternalLeading: %u",fi.dfAscent,fi.dfInternalLeading,fi.dfExternalLeading);
printf("\nItalic: %u, Underline: %u, StrikeOut: %u, Weight: %u",fi.dfItalic,fi.dfUnderline,fi.dfStrikeOut,fi.dfWeight);
printf("\nCharSet: %u, PixWidth: %u, PixHeight: %u",fi.dfCharSet,fi.dfPixWidth,fi.dfPixHeight);
printf("\nVariablePitch: %u, Family: %u",fi.dfPitchAndFamily&15,(fi.dfPitchAndFamily>>4)&15);
printf("\nAvgWidth: %u, MaxWidth: %u",fi.dfAvgWidth,fi.dfMaxWidth);
printf("\nFirstChar: %u, LastChar: %u, DefaultChar: %u, BreakChar: %u",fi.dfFirstChar,fi.dfLastChar,fi.dfDefaultChar,fi.dfBreakChar);
printf("\nWidthBytes: %u, BitsPointer: %lu, BitsOffset: %lu",fi.dfWidthBytes,fi.dfBitsPointer,fi.dfBitsOffset);
	printf("\nReserved: %u",fi.dfReserved);

charmap=(byte **)malloc(nentries);
for(i=0;i<nentries;i++){
  unsigned charsize=((dfCharTable[i].geWidth-1)/8+1)*fi.dfPixHeight;
  int r,c,b;
  charmap[i]=(byte *)malloc(charsize);
  fseek(pf,dfCharTable[i].geOffset+p,SEEK_SET);
  fread(charmap[i],1,charsize,pf);
  printf("\n%.*s  %3d/%3d",dfCharTable[i].geWidth+2,"::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::",i+fi.dfFirstChar,fi.dfLastChar);
  for(r=0;r<fi.dfPixHeight;r++){
    printf("\n:");
    for(c=0;c<(dfCharTable[i].geWidth-1)/8+1;c++){
      for(b=7;b>=0;b--){
	if(charmap[i][r+c*fi.dfPixHeight] & (1<<b))
	  printf("");
	else
	  printf(" ");
	}
      }
    }
  }

/*********************************
** CAUTION: Memory not freed up **
*********************************/

fseek(pf,act,SEEK_SET);
return;}

int main(int argc, char **argv){
char filename[60];
FILE *pf;
int i;
unsigned off, res, align;
struct typeinfo ti;
struct nameinfo ni;

if (argc>1)
  strcpy(filename,argv[1]);
else{
  puts("\nFile name?");
  gets(filename);}

if((pf=fopen(filename,"rb"))==NULL){
  puts("\nUnable to open file");
  return -1;}
fseek(pf,60L,SEEK_SET);
fread(&off,2,1,pf);
fseek(pf,off+36,SEEK_SET);
fread(&res,2,1,pf);
fseek(pf,off+res,SEEK_SET);
fread(&align,2,1,pf);
align=1U<<align;
do{
  fread(&ti,sizeof(struct typeinfo),1,pf);
  if(ti.id==32776U){
    for(i=0;i<ti.n;i++){
      fread(&ni,sizeof(struct nameinfo),1,pf);
      printf("\n%d/%d",i+1,ti.n);
      muestra(ni.off*align,pf);}
    }
  else
    fseek(pf,12*ti.n,SEEK_CUR);
  } while(ti.id!=0U);
return 1;}